=== debian/control ===
Source: lilypond
Build-Depends: debhelper (>= 4.0.0), binutils (>= 2.11.92.0.10-2), libc6-dev (>= 2.2.4-6) | libc6.1-dev (>= 2.2.4-6) | libc0.2-dev (>= 2.2.4-6), python-dev, guile-1.6-dev | libguile-dev, tetex-bin, libkpathsea-dev, tetex-extra, flex (>= 2.5.4a-14) | flex-old, bison (<< 1:1.50) | bison (>> 1:1.75-1), texinfo (>= 4.6-1), groff, m4, gettext (>= 0.10.36-1), mftrace (>= 1.0.17-1), fontforge | pfaedit (>= 0.0.20031020-3), t1utils, imagemagick (>= 5.4.4.5)
Build-Depends-Indep: gs-esp | gs (<= 7.07-1), netpbm (>= 2:9.10-1)
Build-Conflicts-Indep: gs-gpl (>= 8.01) | gs-afpl
Section: tex
Priority: optional
Maintainer: Anthony Fok <foka@debian.org>
Standards-Version: 3.6.1

Package: lilypond
Architecture: any
Replaces: lilypond1.3
Provides: lilypond1.3
Depends: ${shlibs:Depends}, tetex-bin (>= 1.0.5-1), tetex-extra (>= 1.0-1), python, guile-1.6 | guile, ${misc:Depends}, lilypond-data (= ${Source-Version})
# , ec-fonts-mftraced (>= 1.0.5-1)
Recommends: lilypond-doc
Conflicts: lilypond1.3 (<= 1.3.132-1), musixtex-fonts
Description: A program for typesetting sheet music
 LilyPond is a music typesetter, an automated engraving system.  It
 produces beautiful sheet music using a high level description file as input.
 .
 LilyPond supports many forms of music notation constructs, including
 chord names, drum notation, figured bass, grace notes, guitar tablature,
 modern notation (cluster notation and rhythmic grouping), tremolos,
 (nested) tuplets in arbitrary ratios, and more.
 .
 LilyPond's text-based music input language support can integrate into
 LaTeX, HTML and Texinfo seemlessly, allowing single sheet music
 or musicological treatises to be written from a single source.  Form and
 content are separate, and with LilyPond's expert automated formatting,
 users don't need typographical expertise to produce good notation.
 .
 LilyPond produces PostScript and PDF (via TeX) printed output, as well
 as MIDI for listening pleasures.  LilyPond is exported from the
 RoseGarden and NoteEdit GUIs, and can import ABC, ETF and MIDI.
 .
 LilyPond is part of the GNU Project.
 .
  Home Page: http://lilypond.org/
  Authors: Han-Wen Nienhuys <hanwen@cs.uu.nl>
           Jan Nieuwenhuizen <janneke@gnu.org>

Package: lilypond-data
Section: tex
Architecture: all
Depends: tetex-bin
Recommends: lilypond (= ${Source-Version})
Conflicts: lilypond (<< 2.2.2-2)
Description: LilyPond music typesetter (data files)
 LilyPond is a music typesetter, an automated engraving system.  It
 produces beautiful sheet music using a high level description file as input.
 . 
 This package contains architecture-independent data files for LilyPond.

Package: lilypond-doc
Section: doc
Architecture: all
Suggests: lilypond (>= ${Source-Version}), gv | postscript-viewer, mozilla-browser | www-browser
Replaces: lilypond (<= 2.2.3-1), lilypond-data (<= 2.2.3-1)
Description: LilyPond Documentation in HTML, PS and DVI formats
 This package contains the HTML, PostScript and DVI documentation for the
 LilyPond music typesetting software.

Package: lilypond1.3
Architecture: arm i386 m68k powerpc sparc
Depends: lilypond (>= ${Source-Version})
Description: Dummy package for transition to new stable lilypond
 This dummy package provides a transition from the previous lilypond1.3
 package back to a newer lilypond stable releases.
 .
 Please feel free to remove this dummy package after you have upgraded
 to the latest lilypond.
